#ifndef __APPLE__
#  include "Halcon.h"
#  include "hlib/HRLClip.h"
#else
#  ifndef HC_LARGE_IMAGES
#    include <HALCON/Halcon.h>
#    include <HALCON/HRLClip.h>
#  else
#    include <HALCONxl/Halcon.h>
#    include <HALCONxl/HRLClip.h>
#  endif
#endif

#include <conio.h>
#include <stdio.h>
#include <windows.h>
#include <string.h>

typedef struct _beep {
  int no;
  int frequency;
  int time;
}beep;

beep g_extension_beep[100];

Herror CIPCreateBeep(Hproc_handle proc_handle)
{
  static int i = 0;
  Hcpar  *beep_handle, frequency, time;

  HCkP(HAlloc(proc_handle,sizeof(*beep_handle),&beep_handle));

  HGetSPar(proc_handle,1,LONG_PAR,&frequency,1);
  HGetSPar(proc_handle,2,LONG_PAR,&time,1);

  g_extension_beep[i].no = i;
  g_extension_beep[i].frequency = (INT)frequency.par.l;
  g_extension_beep[i].time = (INT)time.par.l;

  beep_handle[0].par.l = i++;
  beep_handle[0].type = LONG_PAR;

  HPutPPar(proc_handle,1,beep_handle,1);

  return H_MSG_TRUE;
}

Herror CIPSetBeepParam(Hproc_handle proc_handle)
{
  Hcpar  beep_handle, param, value;
  int i;

  HAllocStringMem(proc_handle,1000);

  HGetSPar(proc_handle,1,LONG_PAR,&beep_handle,1);
  HGetSPar(proc_handle,2,STRING_PAR,&param,1);
  HGetSPar(proc_handle,3,LONG_PAR,&value,1);

  i = (INT)beep_handle.par.l;

  if (strcmp(param.par.s,"frequency") == 0){
    g_extension_beep[i].frequency = (INT)value.par.l;
  }
  else if (strcmp(param.par.s,"time") == 0){
    g_extension_beep[i].time = (INT)value.par.l;
  }else{
    return H_ERR_WIPV2;
  }

  return H_MSG_TRUE;
}

Herror CIPGetBeepParam(Hproc_handle proc_handle)
{
  Hcpar  beep_handle, param, *value;
  int i;

  HAllocStringMem(proc_handle,1000);
  HCkP(HAlloc(proc_handle,sizeof(*value),&value));

  HGetSPar(proc_handle,1,LONG_PAR,&beep_handle,1);
  HGetSPar(proc_handle,2,STRING_PAR,&param,1);

  i = (INT)beep_handle.par.l;

  if (strcmp(param.par.s,"frequency") == 0){
    value[0].par.l = g_extension_beep[i].frequency;
  }
  else if (strcmp(param.par.s,"time") == 0){
    value[0].par.l = g_extension_beep[i].time;
  }else{
    return H_ERR_WIPV2;
  }
  value[0].type = LONG_PAR;

  HPutPPar(proc_handle,1,value,1);
  return H_MSG_TRUE;
}

Herror CIPCloseBeep(Hproc_handle proc_handle)
{
  return H_MSG_TRUE;
}

Herror CIPSoundBeep(Hproc_handle proc_handle)
{
  Hcpar  beep_handle;

  HGetSPar(proc_handle,1,LONG_PAR,&beep_handle,1);
  Beep(g_extension_beep[(INT)beep_handle.par.l].frequency, g_extension_beep[(INT)beep_handle.par.l].time );
  return H_MSG_TRUE;
}


