/***********************************************************
 * File generated by the HALCON-Compiler hcomp version 11.0
 * Usage: Interface to Microsoft .NET Framework
 *
 * Software by: MVTec Software GmbH, www.mvtec.com
 ***********************************************************/


using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

using Herror = System.Int32;

namespace HalconDotNet
{
  /// <summary></summary>
  public class HBeep
  {

#if (HC_LARGE_IMAGES)
    [DllImport("beepxl")]
#else
    [DllImport("beep")]
#endif

    private static extern int HbeepGetOffset();

    static int offset = -1;

    private static IntPtr PreCallUser(int localProcIndex)
    {
      if (offset < 0)
      {
        /* First use of this extension package, query my offset */
        offset = HbeepGetOffset();
        if (offset < 0)
        {
          /* HALCON libary not initialized (extension package as first usage). */
          /* Trigger initialization by touching Halcon API and try again. */
          IntPtr proc = HalconAPI.PreCall(0);
          HalconAPI.PostCall(proc,HErrorDef.H_MSG_OK);
          offset = HbeepGetOffset();
          if (offset < 0)
          {
            /* Ok, so something is *really* wrong */
            HOperatorException.throwInfo(HErrorDef.H_ERR_UEXTNI, "<unknown>");
          }
        }
      }
      return HalconAPI.PreCall(offset + localProcIndex);
    }

    /// <summary>close beep handle</summary>
    /// <param name="beepHandle"></param>
    public static void CloseBeep(HTuple beepHandle)
    {
      IntPtr proc = PreCallUser(0);
      HalconAPI.Store(proc, 0, beepHandle);
      Herror err = HalconAPI.CallProcedure(proc);
      beepHandle.UnPinTuple();
      HalconAPI.PostCall(proc, err);
    }

    /// <summary>sound beep</summary>
    /// <param name="beepHandle"></param>
    public static void SoundBeep(HTuple beepHandle)
    {
      IntPtr proc = PreCallUser(1);
      HalconAPI.Store(proc, 0, beepHandle);
      Herror err = HalconAPI.CallProcedure(proc);
      beepHandle.UnPinTuple();
      HalconAPI.PostCall(proc, err);
    }

    /// <summary>get the beep parameter</summary>
    /// <param name="beepHandle"></param>
    /// <param name="param"></param>
    /// <param name="value"></param>
    public static void GetBeepParam(HTuple beepHandle, HTuple param, out HTuple value)
    {
      IntPtr proc = PreCallUser(2);
      HalconAPI.Store(proc, 0, beepHandle);
      HalconAPI.Store(proc, 1, param);
      HalconAPI.InitOCT(proc, 0);
      Herror err = HalconAPI.CallProcedure(proc);
      beepHandle.UnPinTuple();
      param.UnPinTuple();
      err = HTuple.LoadNew(proc, 0, HTupleType.INTEGER, err, out value);
      HalconAPI.PostCall(proc, err);
    }

    /// <summary>set the beep parameter</summary>
    /// <param name="beepHandle"></param>
    /// <param name="param"></param>
    /// <param name="value"></param>
    public static void SetBeepParam(HTuple beepHandle, HTuple param, HTuple value)
    {
      IntPtr proc = PreCallUser(3);
      HalconAPI.Store(proc, 0, beepHandle);
      HalconAPI.Store(proc, 1, param);
      HalconAPI.Store(proc, 2, value);
      Herror err = HalconAPI.CallProcedure(proc);
      beepHandle.UnPinTuple();
      param.UnPinTuple();
      value.UnPinTuple();
      HalconAPI.PostCall(proc, err);
    }

    /// <summary>create beep handle</summary>
    /// <param name="frequency"></param>
    /// <param name="time"></param>
    /// <param name="beepHandle"></param>
    public static void CreateBeep(HTuple frequency, HTuple time, out HTuple beepHandle)
    {
      IntPtr proc = PreCallUser(4);
      HalconAPI.Store(proc, 0, frequency);
      HalconAPI.Store(proc, 1, time);
      HalconAPI.InitOCT(proc, 0);
      Herror err = HalconAPI.CallProcedure(proc);
      frequency.UnPinTuple();
      time.UnPinTuple();
      err = HTuple.LoadNew(proc, 0, HTupleType.INTEGER, err, out beepHandle);
      HalconAPI.PostCall(proc, err);
    }

  }
}
